## qtorganizer-eds 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(qtorganizer-eds VERSION 0.2.0
                        DESCRIPTION "QtOrganizer engine for EDS calendar"
                        LANGUAGES CXX)

include(FindPkgConfig)
# Standard install paths
include(GNUInstallDirs)

find_package(Qt5 COMPONENTS Core Organizer Test REQUIRED)
add_compile_definitions(QT_NO_KEYWORDS)

pkg_check_modules(GLIB REQUIRED glib-2.0>=2.32)
pkg_check_modules(GIO REQUIRED gio-2.0>=2.32)
pkg_check_modules(EDATASERVER REQUIRED libedataserver-1.2>=3.8)
pkg_check_modules(ECAL REQUIRED REQUIRED libecal-2.0)
pkg_check_modules(LOMIRI_EDS REQUIRED REQUIRED evolution-data-server-lomiri)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Coverage tools
OPTION(ENABLE_COVERAGE "Build with coverage analysis support" OFF)
if(ENABLE_COVERAGE)
    message(STATUS "Using coverage flags")
    find_program(COVERAGE_COMMAND gcov)
    if(NOT COVERAGE_COMMAND)
        message(FATAL_ERROR "gcov command not found")
    endif()
    SET(CMAKE_C_FLAGS "-g -O0 -Wall -fprofile-arcs -ftest-coverage")
    SET(CMAKE_CXX_FLAGS "-g -O0 -Wall -fprofile-arcs -ftest-coverage")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fprofile-arcs -ftest-coverage -lgcov")
    include(${CMAKE_SOURCE_DIR}/cmake/lcov.cmake)
endif()

# Address Sanitizer
OPTION(ENABLE_ADDRSANITIZER "Build with address sanitizer support" OFF)
if(ENABLE_ADDRSANITIZER)
    message(STATUS "Using address sanitizer flags")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif()


configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
               "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}"
                  -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

#Temporary dir used by tests
execute_process(COMMAND mktemp -d -t qorganizer_eds_test.XXX
                OUTPUT_VARIABLE  TMP_DIR
                OUTPUT_STRIP_TRAILING_WHITESPACE)
#Create the directories
file(MAKE_DIRECTORY ${TMP_DIR}/.cache)
file(MAKE_DIRECTORY ${TMP_DIR}/.config)
file(MAKE_DIRECTORY ${TMP_DIR}/.local/share)

find_program(DBUS_RUNNER dbus-test-runner)
find_program(EVOLUTION_CALENDAR_FACTORY evolution-calendar-factory
             PATHS /usr/lib/evolution/ /usr/libexec/)
find_program(EVOLUTION_SOURCE_REGISTRY evolution-source-registry
             PATHS /usr/lib/evolution/ /usr/libexec/)
find_program(GVFSD gvfsd
             PATHS /usr/lib/gvfs/)

if(EDATASERVER_VERSION VERSION_LESS "3.16")
    set(EVOLUTION_API_3_17 "0")
    set(EVOLUTION_SOURCE_SERVICE_NAME "org.gnome.evolution.dataserver.Sources3")
    set(EVOLUTION_CALENDAR_SERVICE_NAME "org.gnome.evolution.dataserver.Calendar4")
elseif(EDATASERVER_VERSION VERSION_LESS "3.18")
    set(EVOLUTION_API_3_17 "1")
    set(EVOLUTION_SOURCE_SERVICE_NAME "org.gnome.evolution.dataserver.Sources4")
    set(EVOLUTION_CALENDAR_SERVICE_NAME "org.gnome.evolution.dataserver.Calendar7")
elseif(EDATASERVER_VERSION VERSION_LESS "3.34")
    set(EVOLUTION_API_3_17 "1")
    set(EVOLUTION_SOURCE_SERVICE_NAME "org.gnome.evolution.dataserver.Sources5")
    set(EVOLUTION_CALENDAR_SERVICE_NAME "org.gnome.evolution.dataserver.Calendar7")
else()
    set(EVOLUTION_API_3_17 "1")
    set(EVOLUTION_SOURCE_SERVICE_NAME "org.gnome.evolution.dataserver.Sources5")
    set(EVOLUTION_CALENDAR_SERVICE_NAME "org.gnome.evolution.dataserver.Calendar8")
endif()

configure_file(config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(organizer)
if(DBUS_RUNNER)
    if(EVOLUTION_CALENDAR_FACTORY)
        enable_testing()
        add_subdirectory(tests)
    else(EVOLUTION_CALENDAR_FACTORY)
        message(WARNING "evolution-calendar-factory binary not found tests will be disabled")
    endif(EVOLUTION_CALENDAR_FACTORY)
else(DBUS_RUNNER)
    message(WARNING "dbus-test-runner binary not found tests will be disabled")
endif(DBUS_RUNNER)

=== organizer/CMakeLists.txt ===
set(QORGANIZER_BACKEND qtorganizer_eds)

set(QORGANIZER_BACKEND_SRCS
    qorganizer-eds-fetchrequestdata.cpp
    qorganizer-eds-fetchbyidrequestdata.cpp
    qorganizer-eds-fetchocurrencedata.cpp
    qorganizer-eds-engine.cpp
    qorganizer-eds-enginedata.cpp
    qorganizer-eds-parseeventthread.cpp
    qorganizer-eds-removecollectionrequestdata.cpp
    qorganizer-eds-removerequestdata.cpp
    qorganizer-eds-removebyidrequestdata.cpp
    qorganizer-eds-requestdata.cpp
    qorganizer-eds-savecollectionrequestdata.cpp
    qorganizer-eds-saverequestdata.cpp
    qorganizer-eds-viewwatcher.cpp
    qorganizer-eds-source-registry.cpp
)

set(QORGANIZER_BACKEND_HDRS
    qorganizer-eds-fetchrequestdata.h
    qorganizer-eds-fetchbyidrequestdata.h
    qorganizer-eds-fetchocurrencedata.h
    qorganizer-eds-engine.h
    qorganizer-eds-enginedata.h
    qorganizer-eds-parseeventthread.h
    qorganizer-eds-removecollectionrequestdata.h
    qorganizer-eds-removerequestdata.h
    qorganizer-eds-removebyidrequestdata.h
    qorganizer-eds-requestdata.h
    qorganizer-eds-savecollectionrequestdata.h
    qorganizer-eds-saverequestdata.h
    qorganizer-eds-source-registry.h
    qorganizer-eds-viewwatcher.h
)

add_library(${QORGANIZER_BACKEND}-lib STATIC
    ${QORGANIZER_BACKEND_SRCS}
    ${QORGANIZER_BACKEND_HDRS}
)

target_include_directories(${QORGANIZER_BACKEND}-lib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${ECAL_INCLUDE_DIRS}
    ${EDATASERVER_INCLUDE_DIRS}
    ${LOMIRI_EDS_INCLUDE_DIRS}
)

target_link_libraries(${QORGANIZER_BACKEND}-lib PUBLIC
    ${GLIB_LIBRARIES}
    ${ECAL_LIBRARIES}
    ${EDATASERVER_LIBRARIES}
    ${LOMIRI_EDS_LIBRARIES}
    Qt5::Core
    Qt5::Organizer
)

add_library(${QORGANIZER_BACKEND} MODULE
    qorganizer-eds-factory.cpp
    qorganizer-eds-factory.h
)

target_include_directories(${QORGANIZER_BACKEND} PRIVATE
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${ECAL_INCLUDE_DIRS}
    ${EDATASERVER_INCLUDE_DIRS}
    ${LOMIRI_EDS_INCLUDE_DIRS}
)

target_link_libraries(${QORGANIZER_BACKEND} PRIVATE
    ${QORGANIZER_BACKEND}-lib
    ${GLIB_LIBRARIES}
    ${ECAL_LIBRARIES}
    ${EDATASERVER_LIBRARIES}
    ${LOMIRI_EDS_LIBRARIES}
    Qt5::Core
    Qt5::Organizer
)

set(QT_INSTALL_PLUGINS "${CMAKE_INSTALL_LIBDIR}/qt5/plugins" CACHE STRING "Qt5 Plugin Directory")

install(TARGETS ${QORGANIZER_BACKEND} LIBRARY DESTINATION ${QT_INSTALL_PLUGINS}/organizer)

=== tests/unittest/CMakeLists.txt ===
macro(declare_test TESTNAME)
    add_executable(${TESTNAME}
                    ${TESTNAME}.cpp
                    eds-base-test.cpp
                    eds-base-test.h
                    gscopedpointer.h
    )

    if(TEST_XML_OUTPUT)
        set(TEST_ARGS -p -xunitxml -p -o -p test_${testname}.xml)
    else()
        set(TEST_ARGS "")
    endif()

    target_compile_definitions(${TESTNAME} PRIVATE TEST_SUITE)
    target_include_directories(${TESTNAME} PRIVATE
        ${ECAL_INCLUDE_DIRS}
        ${EDATASERVER_INCLUDE_DIRS}
        ${LOMIRI_EDS_INCLUDE_DIRS}
    )

    target_link_libraries(${TESTNAME} PRIVATE
        ${ECAL_LIBRARIES}
        ${EDATASERVER_LIBRARIES}
        ${LOMIRI_EDS_LIBRARIES}
        Qt5::Core
        Qt5::Test
        Qt5::Organizer
        qtorganizer_eds-lib
    )

    add_test(${TESTNAME}
             ${CMAKE_CURRENT_SOURCE_DIR}/run-eds-test.sh ${DBUS_RUNNER} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME} ${TESTNAME}
             ${EVOLUTION_CALENDAR_FACTORY} ${EVOLUTION_CALENDAR_SERVICE_NAME}
             ${EVOLUTION_SOURCE_REGISTRY}  ${EVOLUTION_SOURCE_SERVICE_NAME}
             ${GVFSD})
endmacro(declare_test testname)

declare_test(parseecal-test)
declare_test(collections-test)
declare_test(event-test)
declare_test(fetchitem-test)
declare_test(recurrence-test)
declare_test(cancel-operation-test)
declare_test(filter-test)

=== debian/changelog ===
qtorganizer-eds (0.2.0-3) unstable; urgency=medium

  [ Guido Berhoerster ]
  * debian/patches:
    + Add 2001-temporarily-disable-failing-tests.patch (Closes: #1078314).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 16 Dec 2024 14:30:06 +0100

qtorganizer-eds (0.2.0-2) unstable; urgency=medium

  * debian/upstream/metadata:
    + More renaming (qorganizer-eds -> qtorganizer-eds).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 13 Jul 2024 07:33:35 +0200

qtorganizer-eds (0.2.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1072247).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 20 Jun 2024 22:11:48 +0200

=== debian/control ===
Source: qtorganizer-eds
Section: utils
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake (>= 3.16),
               debhelper-compat (= 13),
               libglib2.0-dev (>=2.62),
               libecal2.0-dev,
               libedataserver1.2-dev (>= 3.12),
               qt5-qmake,
               qtbase5-dev,
               qtpim5-dev (>= 5.0~git20171109~0bd985b),
               evolution-data-server,
               evolution-data-server-lomiri,
               libedataserver-source-lomiri-dev,
               dbus-test-runner,
               gvfs-daemons,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/qtorganizer-eds
Vcs-Git: https://salsa.debian.org/ubports-team/qtorganizer-eds.git
Vcs-Browser: https://salsa.debian.org/ubports-team/qtorganizer-eds

Package: qtorganizer5-eds
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: QtOrganizer engine for EDS calendar
 Qt Organizer provides clients with the ability to access calendar,
 schedule, and personal data in a platform-independent and
 datastore-agnostic manner. This is achieved by defining generic personal
 information data abstractions which can sufficiently describe calendar
 and scheduling data stored in the native calendaring system of a
 platform. Through the plugin architecture, Qt Organizer can be used as a
 front-end API for any calendaring system, such as an online calendar.
 .
 This package provides a QOrganizerEngine implementation using Evolution
 Data Server as storage backend.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export QT_SELECT := qt5

export DPKG_GENSYMBOLS_CHECK_LEVEL=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:
	dh_auto_test --no-parallel

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
